blog/config/routes.rb
Rails.application.routes.draw do
  get 'welcome/index'
  root 'welcome#index'

  devise_for :users, :controllers => { registrations: 'registrations' }
  resources :devise

  resources :users, except: [:show, :destroy] do
    resources :items
  end

  resources :lists do
    resources :items
  end

  resources :items do
    member do
      patch :finish
      put :finish
    end
  end

end

blog/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Todo-NUS</title>
  <%= csrf_meta_tags %>
  <%= csp_meta_tag %>
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no">
  <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
  <%= javascript_include_tag "application", "data-turbolinks-track" => 'reload' %>
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.1.0/css/all.css" integrity="sha384-lKuwvrZot6UHsBSfcMvOkWwlCMgc0TaWr+30HWe3a4ltaBwTZhyTEggF5tJv8tbt" crossorigin="anonymous">
  <script src="https://cdn.jsdelivr.net/npm/gijgo@1.9.6/js/gijgo.min.js" type="text/javascript"></script>
  <link href="https://cdn.jsdelivr.net/npm/gijgo@1.9.6/css/gijgo.min.css" rel="stylesheet" type="text/css" />
  <link href="https://fonts.googleapis.com/css?family=Press+Start+2P" rel="stylesheet">
</head>

<body>
<% #Show Devise views before sign-in, This view below displays after user sign-in successfully%>
<% if user_signed_in? %>
<div class="fixed-nav sticky-footer" id="page-top">
<!-- Navigation-->
  <nav class="navbar navbar-expand-lg navbar-dark bg-dark fixed-top" id="mainNav">
    <a class="navbar-brand" href="http://localhost:3000/"><font class="logo-text">todo-nus</font></a>
    <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarResponsive" aria-controls="navbarResponsive" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarResponsive">
      <ul class="navbar-nav navbar-sidenav" id="exampleAccordion">
        <li class="nav-item" data-toggle="tooltip" data-placement="right" title="Dashboard">
          <a class="nav-link" href="/items">
            <span class="nav-link-text"><i class="fas fa-tachometer-alt"></i> Dashboard</span>
          </a>
        </li>
        <li class="nav-item" data-toggle="tooltip" data-placement="right" title="Components">
          <a class="nav-link nav-link-collapse collapsed" data-toggle="collapse" href="#collapseComponents" data-parent="#exampleAccordion">
            <span class="nav-link-text"><i class="fa fa-fw fa-list"></i> Lists</span>
          </a>
          <ul class="sidenav-second-level collapse" id="collapseComponents">
            <li><%= link_to 'My Lists', lists_path %></li>
            <li><%= link_to 'Shared Lists', users_path %></li>
          </ul>
        </li>
      </ul>
      <ul class="navbar-nav sidenav-toggler">
        <li class="nav-item">
          <a class="nav-link text-center" id="sidenavToggler">
            <i class="fa fa-fw fa-angle-left"></i>
          </a>
        </li>
      </ul>
      <ul class="navbar-nav ml-auto">
        <li class="nav-item dropdown">
          <div class="dropdown">
            <a class="nav-link dropdown-toggle mr-lg-2" id="dropdownMenu1" href="#" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
              <i class="fa fa-fw fa-user color-all-text"></i>
            </a>
            <ul class="dropdown-menu multi-level" role="menu" aria-labelledby="dropdownMenu">
              <li class="dropdown-item">
                <a>
                    <span>Hi! <strong><%= current_user.full_name %></strong></span>
                </a>
              </li>
              <li class="dropdown-divider"></li>
              <li class="dropdown-submenu">
                <a class="dropdown-item" tabindex="-1" href="#">More Options</a>
                <ul class="dropdown-menu">
                  <li id="edit" class="dropdown-item"><a tabindex="-1" href="/users/edit">Edit profile</a></li>
                  <li id="log-out" class="dropdown-item"><a tabindex="-1" data-toggle="modal" data-target="#exampleModal"><i class="fas fa-sign-out-alt"></i> Sign out</a></li>
                </ul>
              </li>
            </ul>
        </div>
        </li>
        <% #If My lists or Shared lists, search engine works with data sources of my lists or shared lists %>
        <% if current_page?(lists_path) || current_page?(users_path) %>
        <li class="nav-item">
          <%= form_for lists_path, :html => {:class => "form-inline my-2 my-lg-0 mr-lg-2"}, :method => 'get' do %>
            <div class="input-group">
            <% #Search engine for My Lists %>
            <% if current_page?(lists_path) %>
              <%= text_field_tag :search, params[:search], autocomplete: "off", data: { autocomplete_source: List.where('user_id = ?',current_user.id).order(:list_name).map(&:list_name)}, class: "form-control mr-sm-2 margin-btn", placeholder: "List Name ..." %>
            <% #Search engine for Shared Lists %>
            <% else %>
              <%= text_field_tag :search, params[:search], autocomplete: "off", data: { autocomplete_source: List.joins("inner join lists_users on lists.id = lists_users.list_id").where("lists_users.user_id = ?",current_user.id).order(:list_name).map(&:list_name)}, class: "form-control mr-sm-2 margin-btn", placeholder: "List Name ..." %>
            <% end %>
              <span>
                <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
              </span>
            </div>
          <% end %>
        </li>
        <% #Search engine does not work %>
        <% else %>
        <li class="nav-item">
            <div class="input-group">
              <%= text_field_tag :search, params[:search], disabled: true, class: "form-control mr-sm-2", placeholder: "Search for ..." %>
              <span class="margin-btn">
                <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
              </span>
            </div>
        </li>
        <% end %>
    </div>
  </nav>
  <div class="content-wrapper">
<% end %>
    <% if user_signed_in? %>
    <% #The content views display in this div after sign-in successfully %>
      <%= yield %>
  </div>
  <!-- /.content-wrapper-->

  <footer class="sticky-footer">
    <div class="container">
    </div>
  </footer>

  <!-- Scroll to Top Button-->
  <a class="scroll-to-top rounded" href="#page-top">
    <i class="fa fa-angle-up"></i>
  </a>

  <!-- Logout Modal-->
  <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Ready to Leave?</h5>
          <button class="close" type="button" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">×</span>
          </button>
        </div>
        <div class="modal-body">Select "Logout" below if you are ready to end your current session.</div>
        <div class="modal-footer">
          <button class="btn btn-secondary" type="button" data-dismiss="modal">Cancel</button>
          <a class="btn btn-primary" rel="nofollow" data-method="delete" href="/users/sign_out">Logout</a>
        </div>
      </div>
    </div>
  </div>
  <% else %>
    <%= yield %>
  <% end %>
</body>
</html>